


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for /private/tmp/im/impacket/impacket/IP6_Extension_Headers.py: 80%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>/private/tmp/im/impacket/impacket/IP6_Extension_Headers.py</b> :
            <span class="pc_cov">80%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            215 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">175 run</span>
            <span class="mis shortkey_m button_toggle_mis">40 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">5 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="pln"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="pln"><a href="#n3">3</a></p>
<p id="n4" class="pln"><a href="#n4">4</a></p>
<p id="n5" class="pln"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="stm run hide_run"><a href="#n7">7</a></p>
<p id="n8" class="pln"><a href="#n8">8</a></p>
<p id="n9" class="stm run hide_run"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="stm run hide_run"><a href="#n11">11</a></p>
<p id="n12" class="pln"><a href="#n12">12</a></p>
<p id="n13" class="pln"><a href="#n13">13</a></p>
<p id="n14" class="pln"><a href="#n14">14</a></p>
<p id="n15" class="pln"><a href="#n15">15</a></p>
<p id="n16" class="stm run hide_run"><a href="#n16">16</a></p>
<p id="n17" class="stm run hide_run"><a href="#n17">17</a></p>
<p id="n18" class="pln"><a href="#n18">18</a></p>
<p id="n19" class="stm run hide_run"><a href="#n19">19</a></p>
<p id="n20" class="pln"><a href="#n20">20</a></p>
<p id="n21" class="stm run hide_run"><a href="#n21">21</a></p>
<p id="n22" class="stm run hide_run"><a href="#n22">22</a></p>
<p id="n23" class="stm run hide_run"><a href="#n23">23</a></p>
<p id="n24" class="stm run hide_run"><a href="#n24">24</a></p>
<p id="n25" class="stm run hide_run"><a href="#n25">25</a></p>
<p id="n26" class="pln"><a href="#n26">26</a></p>
<p id="n27" class="stm run hide_run"><a href="#n27">27</a></p>
<p id="n28" class="pln"><a href="#n28">28</a></p>
<p id="n29" class="stm run hide_run"><a href="#n29">29</a></p>
<p id="n30" class="stm mis"><a href="#n30">30</a></p>
<p id="n31" class="stm mis"><a href="#n31">31</a></p>
<p id="n32" class="stm mis"><a href="#n32">32</a></p>
<p id="n33" class="pln"><a href="#n33">33</a></p>
<p id="n34" class="stm mis"><a href="#n34">34</a></p>
<p id="n35" class="stm mis"><a href="#n35">35</a></p>
<p id="n36" class="stm mis"><a href="#n36">36</a></p>
<p id="n37" class="stm mis"><a href="#n37">37</a></p>
<p id="n38" class="stm mis"><a href="#n38">38</a></p>
<p id="n39" class="pln"><a href="#n39">39</a></p>
<p id="n40" class="stm mis"><a href="#n40">40</a></p>
<p id="n41" class="stm mis"><a href="#n41">41</a></p>
<p id="n42" class="stm mis"><a href="#n42">42</a></p>
<p id="n43" class="stm mis"><a href="#n43">43</a></p>
<p id="n44" class="stm mis"><a href="#n44">44</a></p>
<p id="n45" class="pln"><a href="#n45">45</a></p>
<p id="n46" class="stm mis"><a href="#n46">46</a></p>
<p id="n47" class="pln"><a href="#n47">47</a></p>
<p id="n48" class="stm run hide_run"><a href="#n48">48</a></p>
<p id="n49" class="stm run hide_run"><a href="#n49">49</a></p>
<p id="n50" class="pln"><a href="#n50">50</a></p>
<p id="n51" class="stm run hide_run"><a href="#n51">51</a></p>
<p id="n52" class="stm run hide_run"><a href="#n52">52</a></p>
<p id="n53" class="pln"><a href="#n53">53</a></p>
<p id="n54" class="stm run hide_run"><a href="#n54">54</a></p>
<p id="n55" class="stm par run hide_run"><a href="#n55">55</a></p>
<p id="n56" class="stm mis"><a href="#n56">56</a></p>
<p id="n57" class="pln"><a href="#n57">57</a></p>
<p id="n58" class="stm run hide_run"><a href="#n58">58</a></p>
<p id="n59" class="stm run hide_run"><a href="#n59">59</a></p>
<p id="n60" class="stm run hide_run"><a href="#n60">60</a></p>
<p id="n61" class="pln"><a href="#n61">61</a></p>
<p id="n62" class="stm run hide_run"><a href="#n62">62</a></p>
<p id="n63" class="pln"><a href="#n63">63</a></p>
<p id="n64" class="stm run hide_run"><a href="#n64">64</a></p>
<p id="n65" class="stm run hide_run"><a href="#n65">65</a></p>
<p id="n66" class="pln"><a href="#n66">66</a></p>
<p id="n67" class="pln"><a href="#n67">67</a></p>
<p id="n68" class="pln"><a href="#n68">68</a></p>
<p id="n69" class="pln"><a href="#n69">69</a></p>
<p id="n70" class="pln"><a href="#n70">70</a></p>
<p id="n71" class="stm run hide_run"><a href="#n71">71</a></p>
<p id="n72" class="stm run hide_run"><a href="#n72">72</a></p>
<p id="n73" class="pln"><a href="#n73">73</a></p>
<p id="n74" class="stm run hide_run"><a href="#n74">74</a></p>
<p id="n75" class="pln"><a href="#n75">75</a></p>
<p id="n76" class="stm run hide_run"><a href="#n76">76</a></p>
<p id="n77" class="stm run hide_run"><a href="#n77">77</a></p>
<p id="n78" class="pln"><a href="#n78">78</a></p>
<p id="n79" class="stm run hide_run"><a href="#n79">79</a></p>
<p id="n80" class="stm mis"><a href="#n80">80</a></p>
<p id="n81" class="pln"><a href="#n81">81</a></p>
<p id="n82" class="stm run hide_run"><a href="#n82">82</a></p>
<p id="n83" class="pln"><a href="#n83">83</a></p>
<p id="n84" class="stm run hide_run"><a href="#n84">84</a></p>
<p id="n85" class="pln"><a href="#n85">85</a></p>
<p id="n86" class="stm run hide_run"><a href="#n86">86</a></p>
<p id="n87" class="pln"><a href="#n87">87</a></p>
<p id="n88" class="stm run hide_run"><a href="#n88">88</a></p>
<p id="n89" class="stm run hide_run"><a href="#n89">89</a></p>
<p id="n90" class="stm run hide_run"><a href="#n90">90</a></p>
<p id="n91" class="stm run hide_run"><a href="#n91">91</a></p>
<p id="n92" class="pln"><a href="#n92">92</a></p>
<p id="n93" class="pln"><a href="#n93">93</a></p>
<p id="n94" class="pln"><a href="#n94">94</a></p>
<p id="n95" class="stm run hide_run"><a href="#n95">95</a></p>
<p id="n96" class="pln"><a href="#n96">96</a></p>
<p id="n97" class="pln"><a href="#n97">97</a></p>
<p id="n98" class="stm run hide_run"><a href="#n98">98</a></p>
<p id="n99" class="stm run hide_run"><a href="#n99">99</a></p>
<p id="n100" class="pln"><a href="#n100">100</a></p>
<p id="n101" class="stm run hide_run"><a href="#n101">101</a></p>
<p id="n102" class="pln"><a href="#n102">102</a></p>
<p id="n103" class="stm mis"><a href="#n103">103</a></p>
<p id="n104" class="pln"><a href="#n104">104</a></p>
<p id="n105" class="stm run hide_run"><a href="#n105">105</a></p>
<p id="n106" class="stm run hide_run"><a href="#n106">106</a></p>
<p id="n107" class="pln"><a href="#n107">107</a></p>
<p id="n108" class="stm run hide_run"><a href="#n108">108</a></p>
<p id="n109" class="stm run hide_run"><a href="#n109">109</a></p>
<p id="n110" class="pln"><a href="#n110">110</a></p>
<p id="n111" class="stm run hide_run"><a href="#n111">111</a></p>
<p id="n112" class="stm run hide_run"><a href="#n112">112</a></p>
<p id="n113" class="stm run hide_run"><a href="#n113">113</a></p>
<p id="n114" class="stm run hide_run"><a href="#n114">114</a></p>
<p id="n115" class="stm run hide_run"><a href="#n115">115</a></p>
<p id="n116" class="pln"><a href="#n116">116</a></p>
<p id="n117" class="stm run hide_run"><a href="#n117">117</a></p>
<p id="n118" class="stm run hide_run"><a href="#n118">118</a></p>
<p id="n119" class="pln"><a href="#n119">119</a></p>
<p id="n120" class="stm run hide_run"><a href="#n120">120</a></p>
<p id="n121" class="stm run hide_run"><a href="#n121">121</a></p>
<p id="n122" class="pln"><a href="#n122">122</a></p>
<p id="n123" class="stm run hide_run"><a href="#n123">123</a></p>
<p id="n124" class="stm run hide_run"><a href="#n124">124</a></p>
<p id="n125" class="pln"><a href="#n125">125</a></p>
<p id="n126" class="stm run hide_run"><a href="#n126">126</a></p>
<p id="n127" class="stm run hide_run"><a href="#n127">127</a></p>
<p id="n128" class="pln"><a href="#n128">128</a></p>
<p id="n129" class="stm run hide_run"><a href="#n129">129</a></p>
<p id="n130" class="stm run hide_run"><a href="#n130">130</a></p>
<p id="n131" class="pln"><a href="#n131">131</a></p>
<p id="n132" class="stm run hide_run"><a href="#n132">132</a></p>
<p id="n133" class="stm run hide_run"><a href="#n133">133</a></p>
<p id="n134" class="pln"><a href="#n134">134</a></p>
<p id="n135" class="stm run hide_run"><a href="#n135">135</a></p>
<p id="n136" class="stm run hide_run"><a href="#n136">136</a></p>
<p id="n137" class="pln"><a href="#n137">137</a></p>
<p id="n138" class="pln"><a href="#n138">138</a></p>
<p id="n139" class="stm run hide_run"><a href="#n139">139</a></p>
<p id="n140" class="pln"><a href="#n140">140</a></p>
<p id="n141" class="pln"><a href="#n141">141</a></p>
<p id="n142" class="stm run hide_run"><a href="#n142">142</a></p>
<p id="n143" class="stm run hide_run"><a href="#n143">143</a></p>
<p id="n144" class="stm run hide_run"><a href="#n144">144</a></p>
<p id="n145" class="pln"><a href="#n145">145</a></p>
<p id="n146" class="stm run hide_run"><a href="#n146">146</a></p>
<p id="n147" class="stm run hide_run"><a href="#n147">147</a></p>
<p id="n148" class="pln"><a href="#n148">148</a></p>
<p id="n149" class="stm run hide_run"><a href="#n149">149</a></p>
<p id="n150" class="pln"><a href="#n150">150</a></p>
<p id="n151" class="stm run hide_run"><a href="#n151">151</a></p>
<p id="n152" class="stm run hide_run"><a href="#n152">152</a></p>
<p id="n153" class="stm run hide_run"><a href="#n153">153</a></p>
<p id="n154" class="stm run hide_run"><a href="#n154">154</a></p>
<p id="n155" class="pln"><a href="#n155">155</a></p>
<p id="n156" class="stm run hide_run"><a href="#n156">156</a></p>
<p id="n157" class="pln"><a href="#n157">157</a></p>
<p id="n158" class="pln"><a href="#n158">158</a></p>
<p id="n159" class="stm mis"><a href="#n159">159</a></p>
<p id="n160" class="pln"><a href="#n160">160</a></p>
<p id="n161" class="stm run hide_run"><a href="#n161">161</a></p>
<p id="n162" class="stm run hide_run"><a href="#n162">162</a></p>
<p id="n163" class="stm run hide_run"><a href="#n163">163</a></p>
<p id="n164" class="pln"><a href="#n164">164</a></p>
<p id="n165" class="stm run hide_run"><a href="#n165">165</a></p>
<p id="n166" class="stm par run hide_run"><a href="#n166">166</a></p>
<p id="n167" class="stm mis"><a href="#n167">167</a></p>
<p id="n168" class="stm run hide_run"><a href="#n168">168</a></p>
<p id="n169" class="stm run hide_run"><a href="#n169">169</a></p>
<p id="n170" class="pln"><a href="#n170">170</a></p>
<p id="n171" class="stm run hide_run"><a href="#n171">171</a></p>
<p id="n172" class="stm mis"><a href="#n172">172</a></p>
<p id="n173" class="stm mis"><a href="#n173">173</a></p>
<p id="n174" class="pln"><a href="#n174">174</a></p>
<p id="n175" class="stm mis"><a href="#n175">175</a></p>
<p id="n176" class="stm mis"><a href="#n176">176</a></p>
<p id="n177" class="stm mis"><a href="#n177">177</a></p>
<p id="n178" class="pln"><a href="#n178">178</a></p>
<p id="n179" class="stm mis"><a href="#n179">179</a></p>
<p id="n180" class="pln"><a href="#n180">180</a></p>
<p id="n181" class="stm run hide_run"><a href="#n181">181</a></p>
<p id="n182" class="stm run hide_run"><a href="#n182">182</a></p>
<p id="n183" class="pln"><a href="#n183">183</a></p>
<p id="n184" class="stm run hide_run"><a href="#n184">184</a></p>
<p id="n185" class="stm run hide_run"><a href="#n185">185</a></p>
<p id="n186" class="pln"><a href="#n186">186</a></p>
<p id="n187" class="stm run hide_run"><a href="#n187">187</a></p>
<p id="n188" class="stm run hide_run"><a href="#n188">188</a></p>
<p id="n189" class="pln"><a href="#n189">189</a></p>
<p id="n190" class="stm run hide_run"><a href="#n190">190</a></p>
<p id="n191" class="stm run hide_run"><a href="#n191">191</a></p>
<p id="n192" class="pln"><a href="#n192">192</a></p>
<p id="n193" class="stm run hide_run"><a href="#n193">193</a></p>
<p id="n194" class="stm run hide_run"><a href="#n194">194</a></p>
<p id="n195" class="stm run hide_run"><a href="#n195">195</a></p>
<p id="n196" class="pln"><a href="#n196">196</a></p>
<p id="n197" class="stm run hide_run"><a href="#n197">197</a></p>
<p id="n198" class="stm run hide_run"><a href="#n198">198</a></p>
<p id="n199" class="stm run hide_run"><a href="#n199">199</a></p>
<p id="n200" class="pln"><a href="#n200">200</a></p>
<p id="n201" class="stm run hide_run"><a href="#n201">201</a></p>
<p id="n202" class="stm run hide_run"><a href="#n202">202</a></p>
<p id="n203" class="pln"><a href="#n203">203</a></p>
<p id="n204" class="stm run hide_run"><a href="#n204">204</a></p>
<p id="n205" class="stm run hide_run"><a href="#n205">205</a></p>
<p id="n206" class="stm run hide_run"><a href="#n206">206</a></p>
<p id="n207" class="pln"><a href="#n207">207</a></p>
<p id="n208" class="stm run hide_run"><a href="#n208">208</a></p>
<p id="n209" class="stm run hide_run"><a href="#n209">209</a></p>
<p id="n210" class="pln"><a href="#n210">210</a></p>
<p id="n211" class="stm run hide_run"><a href="#n211">211</a></p>
<p id="n212" class="stm run hide_run"><a href="#n212">212</a></p>
<p id="n213" class="pln"><a href="#n213">213</a></p>
<p id="n214" class="stm run hide_run"><a href="#n214">214</a></p>
<p id="n215" class="stm run hide_run"><a href="#n215">215</a></p>
<p id="n216" class="stm run hide_run"><a href="#n216">216</a></p>
<p id="n217" class="pln"><a href="#n217">217</a></p>
<p id="n218" class="stm run hide_run"><a href="#n218">218</a></p>
<p id="n219" class="stm par run hide_run"><a href="#n219">219</a></p>
<p id="n220" class="stm mis"><a href="#n220">220</a></p>
<p id="n221" class="pln"><a href="#n221">221</a></p>
<p id="n222" class="stm run hide_run"><a href="#n222">222</a></p>
<p id="n223" class="stm run hide_run"><a href="#n223">223</a></p>
<p id="n224" class="pln"><a href="#n224">224</a></p>
<p id="n225" class="stm run hide_run"><a href="#n225">225</a></p>
<p id="n226" class="stm run hide_run"><a href="#n226">226</a></p>
<p id="n227" class="stm run hide_run"><a href="#n227">227</a></p>
<p id="n228" class="stm run hide_run"><a href="#n228">228</a></p>
<p id="n229" class="pln"><a href="#n229">229</a></p>
<p id="n230" class="stm run hide_run"><a href="#n230">230</a></p>
<p id="n231" class="stm run hide_run"><a href="#n231">231</a></p>
<p id="n232" class="stm run hide_run"><a href="#n232">232</a></p>
<p id="n233" class="pln"><a href="#n233">233</a></p>
<p id="n234" class="stm run hide_run"><a href="#n234">234</a></p>
<p id="n235" class="stm run hide_run"><a href="#n235">235</a></p>
<p id="n236" class="stm run hide_run"><a href="#n236">236</a></p>
<p id="n237" class="stm run hide_run"><a href="#n237">237</a></p>
<p id="n238" class="pln"><a href="#n238">238</a></p>
<p id="n239" class="stm run hide_run"><a href="#n239">239</a></p>
<p id="n240" class="stm run hide_run"><a href="#n240">240</a></p>
<p id="n241" class="stm run hide_run"><a href="#n241">241</a></p>
<p id="n242" class="stm run hide_run"><a href="#n242">242</a></p>
<p id="n243" class="pln"><a href="#n243">243</a></p>
<p id="n244" class="stm run hide_run"><a href="#n244">244</a></p>
<p id="n245" class="pln"><a href="#n245">245</a></p>
<p id="n246" class="stm run hide_run"><a href="#n246">246</a></p>
<p id="n247" class="pln"><a href="#n247">247</a></p>
<p id="n248" class="stm run hide_run"><a href="#n248">248</a></p>
<p id="n249" class="stm run hide_run"><a href="#n249">249</a></p>
<p id="n250" class="stm par run hide_run"><a href="#n250">250</a></p>
<p id="n251" class="stm mis"><a href="#n251">251</a></p>
<p id="n252" class="pln"><a href="#n252">252</a></p>
<p id="n253" class="pln"><a href="#n253">253</a></p>
<p id="n254" class="stm run hide_run"><a href="#n254">254</a></p>
<p id="n255" class="stm par run hide_run"><a href="#n255">255</a></p>
<p id="n256" class="stm mis"><a href="#n256">256</a></p>
<p id="n257" class="pln"><a href="#n257">257</a></p>
<p id="n258" class="stm run hide_run"><a href="#n258">258</a></p>
<p id="n259" class="stm run hide_run"><a href="#n259">259</a></p>
<p id="n260" class="pln"><a href="#n260">260</a></p>
<p id="n261" class="stm run hide_run"><a href="#n261">261</a></p>
<p id="n262" class="pln"><a href="#n262">262</a></p>
<p id="n263" class="stm run hide_run"><a href="#n263">263</a></p>
<p id="n264" class="stm run hide_run"><a href="#n264">264</a></p>
<p id="n265" class="stm run hide_run"><a href="#n265">265</a></p>
<p id="n266" class="pln"><a href="#n266">266</a></p>
<p id="n267" class="stm run hide_run"><a href="#n267">267</a></p>
<p id="n268" class="pln"><a href="#n268">268</a></p>
<p id="n269" class="stm run hide_run"><a href="#n269">269</a></p>
<p id="n270" class="stm run hide_run"><a href="#n270">270</a></p>
<p id="n271" class="pln"><a href="#n271">271</a></p>
<p id="n272" class="stm run hide_run"><a href="#n272">272</a></p>
<p id="n273" class="stm run hide_run"><a href="#n273">273</a></p>
<p id="n274" class="stm run hide_run"><a href="#n274">274</a></p>
<p id="n275" class="pln"><a href="#n275">275</a></p>
<p id="n276" class="stm run hide_run"><a href="#n276">276</a></p>
<p id="n277" class="pln"><a href="#n277">277</a></p>
<p id="n278" class="stm run hide_run"><a href="#n278">278</a></p>
<p id="n279" class="stm run hide_run"><a href="#n279">279</a></p>
<p id="n280" class="pln"><a href="#n280">280</a></p>
<p id="n281" class="stm run hide_run"><a href="#n281">281</a></p>
<p id="n282" class="stm run hide_run"><a href="#n282">282</a></p>
<p id="n283" class="stm run hide_run"><a href="#n283">283</a></p>
<p id="n284" class="stm run hide_run"><a href="#n284">284</a></p>
<p id="n285" class="pln"><a href="#n285">285</a></p>
<p id="n286" class="stm run hide_run"><a href="#n286">286</a></p>
<p id="n287" class="stm run hide_run"><a href="#n287">287</a></p>
<p id="n288" class="stm run hide_run"><a href="#n288">288</a></p>
<p id="n289" class="stm run hide_run"><a href="#n289">289</a></p>
<p id="n290" class="stm run hide_run"><a href="#n290">290</a></p>
<p id="n291" class="pln"><a href="#n291">291</a></p>
<p id="n292" class="stm run hide_run"><a href="#n292">292</a></p>
<p id="n293" class="stm mis"><a href="#n293">293</a></p>
<p id="n294" class="stm mis"><a href="#n294">294</a></p>
<p id="n295" class="stm mis"><a href="#n295">295</a></p>
<p id="n296" class="stm mis"><a href="#n296">296</a></p>
<p id="n297" class="stm mis"><a href="#n297">297</a></p>
<p id="n298" class="pln"><a href="#n298">298</a></p>
<p id="n299" class="stm mis"><a href="#n299">299</a></p>
<p id="n300" class="stm mis"><a href="#n300">300</a></p>
<p id="n301" class="stm mis"><a href="#n301">301</a></p>
<p id="n302" class="stm mis"><a href="#n302">302</a></p>
<p id="n303" class="stm mis"><a href="#n303">303</a></p>
<p id="n304" class="stm mis"><a href="#n304">304</a></p>
<p id="n305" class="pln"><a href="#n305">305</a></p>
<p id="n306" class="stm mis"><a href="#n306">306</a></p>
<p id="n307" class="pln"><a href="#n307">307</a></p>
<p id="n308" class="stm run hide_run"><a href="#n308">308</a></p>
<p id="n309" class="pln"><a href="#n309">309</a></p>
<p id="n310" class="stm run hide_run"><a href="#n310">310</a></p>
<p id="n311" class="stm run hide_run"><a href="#n311">311</a></p>
<p id="n312" class="pln"><a href="#n312">312</a></p>
<p id="n313" class="stm run hide_run"><a href="#n313">313</a></p>
<p id="n314" class="stm run hide_run"><a href="#n314">314</a></p>
<p id="n315" class="pln"><a href="#n315">315</a></p>
<p id="n316" class="stm run hide_run"><a href="#n316">316</a></p>
<p id="n317" class="stm run hide_run"><a href="#n317">317</a></p>
<p id="n318" class="pln"><a href="#n318">318</a></p>
<p id="n319" class="stm run hide_run"><a href="#n319">319</a></p>
<p id="n320" class="stm run hide_run"><a href="#n320">320</a></p>
<p id="n321" class="pln"><a href="#n321">321</a></p>
<p id="n322" class="stm run hide_run"><a href="#n322">322</a></p>
<p id="n323" class="stm run hide_run"><a href="#n323">323</a></p>
<p id="n324" class="pln"><a href="#n324">324</a></p>
<p id="n325" class="stm run hide_run"><a href="#n325">325</a></p>
<p id="n326" class="stm run hide_run"><a href="#n326">326</a></p>

            </td>
            <td class="text">
<p id="t1" class="pln"><span class="com"># SECUREAUTH LABS. Copyright 2018 SecureAuth Corporation. All rights reserved.</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="pln"><span class="com"># This software is provided under under a slightly modified version</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="pln"><span class="com"># of the Apache Software License. See the accompanying LICENSE file</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="pln"><span class="com"># for more information.</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="stm run hide_run"><span class="key">import</span> <span class="nam">array</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t9" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">ImpactPacket</span> <span class="key">import</span> <span class="nam">Header</span><span class="op">,</span> <span class="nam">ImpactPacketException</span><span class="op">,</span> <span class="nam">PacketBuffer</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t11" class="stm run hide_run"><span class="key">class</span> <span class="nam">IP6_Extension_Header</span><span class="op">(</span><span class="nam">Header</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="pln"><span class="com"># --------------------------------- - - - - - - -</span><span class="strut">&nbsp;</span></p>
<p id="t13" class="pln"><span class="com"># | Next Header | Header Ext Len | Options</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="pln"><span class="com"># --------------------------------- - - - - - - -</span><span class="strut">&nbsp;</span></p>
<p id="t15" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t16" class="stm run hide_run">    <span class="nam">HEADER_TYPE_VALUE</span> <span class="op">=</span> <span class="op">-</span><span class="num">1</span><span class="strut">&nbsp;</span></p>
<p id="t17" class="stm run hide_run">    <span class="nam">EXTENSION_HEADER_FIELDS_SIZE</span> <span class="op">=</span> <span class="num">2</span><span class="strut">&nbsp;</span></p>
<p id="t18" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t19" class="stm run hide_run">    <span class="nam">EXTENSION_HEADER_DECODER</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t20" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t21" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">buffer</span> <span class="op">=</span> <span class="key">None</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t22" class="stm run hide_run">        <span class="nam">Header</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_headers_field_size</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t23" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">_option_list</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="stm run hide_run">        <span class="key">if</span> <span class="nam">buffer</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t25" class="stm run hide_run">            <span class="nam">self</span><span class="op">.</span><span class="nam">load_header</span><span class="op">(</span><span class="nam">buffer</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t26" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t27" class="stm run hide_run">            <span class="nam">self</span><span class="op">.</span><span class="nam">reset</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t29" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__str__</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="stm mis">        <span class="nam">header_type</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_header_type</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t31" class="stm mis">        <span class="nam">next_header_value</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_next_header</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t32" class="stm mis">        <span class="nam">header_ext_length</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_header_extension_length</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t34" class="stm mis">        <span class="nam">s</span>  <span class="op">=</span> <span class="str">"Header Extension Name: "</span> <span class="op">+</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__class__</span><span class="op">.</span><span class="nam">HEADER_EXTENSION_DESCRIPTION</span> <span class="op">+</span> <span class="str">"\n"</span><span class="strut">&nbsp;</span></p>
<p id="t35" class="stm mis">        <span class="nam">s</span> <span class="op">+=</span> <span class="str">"Header Type Value: "</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">header_type</span><span class="op">)</span> <span class="op">+</span> <span class="str">"\n"</span><span class="strut">&nbsp;</span></p>
<p id="t36" class="stm mis">        <span class="nam">s</span> <span class="op">+=</span> <span class="str">"Next Header: "</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">next_header_value</span><span class="op">)</span> <span class="op">+</span> <span class="str">"\n"</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="stm mis">        <span class="nam">s</span> <span class="op">+=</span> <span class="str">"Header Extension Length: "</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">header_ext_length</span><span class="op">)</span> <span class="op">+</span> <span class="str">"\n"</span><span class="strut">&nbsp;</span></p>
<p id="t38" class="stm mis">        <span class="nam">s</span> <span class="op">+=</span> <span class="str">"Options:\n"</span><span class="strut">&nbsp;</span></p>
<p id="t39" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t40" class="stm mis">        <span class="key">for</span> <span class="nam">option</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_option_list</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="stm mis">            <span class="nam">option_str</span> <span class="op">=</span> <span class="nam">str</span><span class="op">(</span><span class="nam">option</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t42" class="stm mis">            <span class="nam">option_str</span> <span class="op">=</span> <span class="nam">option_str</span><span class="op">.</span><span class="nam">split</span><span class="op">(</span><span class="str">'\n'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="stm mis">            <span class="nam">option_str</span> <span class="op">=</span> <span class="op">[</span><span class="op">(</span><span class="str">' '</span> <span class="op">*</span> <span class="num">4</span><span class="op">)</span> <span class="op">+</span> <span class="nam">s</span> <span class="key">for</span> <span class="nam">s</span> <span class="key">in</span> <span class="nam">option_str</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t44" class="stm mis">            <span class="nam">s</span> <span class="op">+=</span> <span class="str">'\n'</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="nam">option_str</span><span class="op">)</span> <span class="op">+</span> <span class="str">'\n'</span><span class="strut">&nbsp;</span></p>
<p id="t45" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t46" class="stm mis">        <span class="key">return</span> <span class="nam">s</span><span class="strut">&nbsp;</span></p>
<p id="t47" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t48" class="stm run hide_run">    <span class="key">def</span> <span class="nam">load_header</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">buffer</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">set_bytes_from_string</span><span class="op">(</span><span class="nam">buffer</span><span class="op">[</span><span class="op">:</span><span class="nam">self</span><span class="op">.</span><span class="nam">get_headers_field_size</span><span class="op">(</span><span class="op">)</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t50" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t51" class="stm run hide_run">        <span class="nam">remaining_bytes</span> <span class="op">=</span> <span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">get_header_extension_length</span><span class="op">(</span><span class="op">)</span> <span class="op">+</span> <span class="num">1</span><span class="op">)</span> <span class="op">*</span> <span class="num">8</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="stm run hide_run">        <span class="nam">remaining_bytes</span> <span class="op">-=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_headers_field_size</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t53" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t54" class="stm run hide_run">        <span class="nam">buffer</span> <span class="op">=</span> <span class="nam">array</span><span class="op">.</span><span class="nam">array</span><span class="op">(</span><span class="str">'B'</span><span class="op">,</span> <span class="nam">buffer</span><span class="op">[</span><span class="nam">self</span><span class="op">.</span><span class="nam">get_headers_field_size</span><span class="op">(</span><span class="op">)</span><span class="op">:</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t55" class="stm par run hide_run"><span class="annotate short">55&#x202F;&#x219B;&#x202F;56</span><span class="annotate long">line 55 didn't jump to line 56, because the condition on line 55 was never true</span>        <span class="key">if</span> <span class="nam">remaining_bytes</span> <span class="op">></span> <span class="nam">len</span><span class="op">(</span><span class="nam">buffer</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t56" class="stm mis">            <span class="key">raise</span> <span class="nam">ImpactPacketException</span><span class="op">(</span><span class="str">"Cannot load options from truncated packet"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t57" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t58" class="stm run hide_run">        <span class="key">while</span> <span class="nam">remaining_bytes</span> <span class="op">></span> <span class="num">0</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t59" class="stm run hide_run">            <span class="nam">option_type</span> <span class="op">=</span> <span class="nam">buffer</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t60" class="stm run hide_run">            <span class="key">if</span> <span class="nam">option_type</span> <span class="op">==</span> <span class="nam">Option_PAD1</span><span class="op">.</span><span class="nam">OPTION_TYPE_VALUE</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t61" class="pln">                <span class="com"># Pad1</span><span class="strut">&nbsp;</span></p>
<p id="t62" class="stm run hide_run">                <span class="nam">self</span><span class="op">.</span><span class="nam">_option_list</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">Option_PAD1</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t63" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t64" class="stm run hide_run">                <span class="nam">remaining_bytes</span> <span class="op">-=</span> <span class="num">1</span><span class="strut">&nbsp;</span></p>
<p id="t65" class="stm run hide_run">                <span class="nam">buffer</span> <span class="op">=</span> <span class="nam">buffer</span><span class="op">[</span><span class="num">1</span><span class="op">:</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t66" class="pln">            <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t67" class="pln">                <span class="com"># PadN</span><span class="strut">&nbsp;</span></p>
<p id="t68" class="pln">                <span class="com"># From RFC 2460: For N octets of padding, the Opt Data Len</span><span class="strut">&nbsp;</span></p>
<p id="t69" class="pln">                <span class="com"># field contains the value N-2, and the Option Data consists</span><span class="strut">&nbsp;</span></p>
<p id="t70" class="pln">                <span class="com"># of N-2 zero-valued octets.</span><span class="strut">&nbsp;</span></p>
<p id="t71" class="stm run hide_run">                <span class="nam">option_length</span> <span class="op">=</span> <span class="nam">buffer</span><span class="op">[</span><span class="num">1</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t72" class="stm run hide_run">                <span class="nam">option_length</span> <span class="op">+=</span> <span class="num">2</span><span class="strut">&nbsp;</span></p>
<p id="t73" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t74" class="stm run hide_run">                <span class="nam">self</span><span class="op">.</span><span class="nam">_option_list</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">Option_PADN</span><span class="op">(</span><span class="nam">option_length</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t75" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t76" class="stm run hide_run">                <span class="nam">remaining_bytes</span> <span class="op">-=</span> <span class="nam">option_length</span><span class="strut">&nbsp;</span></p>
<p id="t77" class="stm run hide_run">                <span class="nam">buffer</span> <span class="op">=</span> <span class="nam">buffer</span><span class="op">[</span><span class="nam">option_length</span><span class="op">:</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t78" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t79" class="stm run hide_run">    <span class="key">def</span> <span class="nam">reset</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t80" class="stm mis">        <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t81" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t82" class="stm run hide_run">    <span class="op">@</span><span class="nam">classmethod</span><span class="strut">&nbsp;</span></p>
<p id="t83" class="pln">    <span class="key">def</span> <span class="nam">get_header_type_value</span><span class="op">(</span><span class="nam">cls</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t84" class="stm run hide_run">        <span class="key">return</span> <span class="nam">cls</span><span class="op">.</span><span class="nam">HEADER_TYPE_VALUE</span><span class="strut">&nbsp;</span></p>
<p id="t85" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t86" class="stm run hide_run">    <span class="op">@</span><span class="nam">classmethod</span><span class="strut">&nbsp;</span></p>
<p id="t87" class="pln">    <span class="key">def</span> <span class="nam">get_extension_headers</span><span class="op">(</span><span class="nam">cls</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t88" class="stm run hide_run">        <span class="nam">header_types</span> <span class="op">=</span> <span class="op">{</span><span class="op">}</span><span class="strut">&nbsp;</span></p>
<p id="t89" class="stm run hide_run">        <span class="key">for</span> <span class="nam">subclass</span> <span class="key">in</span> <span class="nam">cls</span><span class="op">.</span><span class="nam">__subclasses__</span><span class="op">(</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t90" class="stm run hide_run">            <span class="nam">subclass_header_types</span> <span class="op">=</span> <span class="nam">subclass</span><span class="op">.</span><span class="nam">get_extension_headers</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t91" class="stm run hide_run">            <span class="key">if</span> <span class="key">not</span> <span class="nam">subclass_header_types</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t92" class="pln">                <span class="com"># If the subclass did not return anything it means</span><span class="strut">&nbsp;</span></p>
<p id="t93" class="pln">                <span class="com"># that it is a leaf subclass, so we take its header</span><span class="strut">&nbsp;</span></p>
<p id="t94" class="pln">                <span class="com"># type value</span><span class="strut">&nbsp;</span></p>
<p id="t95" class="stm run hide_run">                <span class="nam">header_types</span><span class="op">[</span><span class="nam">subclass</span><span class="op">.</span><span class="nam">get_header_type_value</span><span class="op">(</span><span class="op">)</span><span class="op">]</span> <span class="op">=</span> <span class="nam">subclass</span><span class="strut">&nbsp;</span></p>
<p id="t96" class="pln">            <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t97" class="pln">                <span class="com"># Else we extend the list of the obtained types</span><span class="strut">&nbsp;</span></p>
<p id="t98" class="stm run hide_run">                <span class="nam">header_types</span><span class="op">.</span><span class="nam">update</span><span class="op">(</span><span class="nam">subclass_header_types</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t99" class="stm run hide_run">        <span class="key">return</span> <span class="nam">header_types</span><span class="strut">&nbsp;</span></p>
<p id="t100" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t101" class="stm run hide_run">    <span class="op">@</span><span class="nam">classmethod</span><span class="strut">&nbsp;</span></p>
<p id="t102" class="pln">    <span class="key">def</span> <span class="nam">get_decoder</span><span class="op">(</span><span class="nam">cls</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t103" class="stm mis">        <span class="key">raise</span> <span class="nam">RuntimeError</span><span class="op">(</span><span class="str">"Class method %s.get_decoder must be overridden."</span> <span class="op">%</span> <span class="nam">cls</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t104" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t105" class="stm run hide_run">    <span class="key">def</span> <span class="nam">get_header_type</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t106" class="stm run hide_run">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__class__</span><span class="op">.</span><span class="nam">get_header_type_value</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t107" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t108" class="stm run hide_run">    <span class="key">def</span> <span class="nam">get_headers_field_size</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t109" class="stm run hide_run">        <span class="key">return</span> <span class="nam">IP6_Extension_Header</span><span class="op">.</span><span class="nam">EXTENSION_HEADER_FIELDS_SIZE</span><span class="strut">&nbsp;</span></p>
<p id="t110" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t111" class="stm run hide_run">    <span class="key">def</span> <span class="nam">get_header_size</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t112" class="stm run hide_run">        <span class="nam">header_size</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_headers_field_size</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t113" class="stm run hide_run">        <span class="key">for</span> <span class="nam">option</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_option_list</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t114" class="stm run hide_run">            <span class="nam">header_size</span> <span class="op">+=</span> <span class="nam">option</span><span class="op">.</span><span class="nam">get_len</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t115" class="stm run hide_run">        <span class="key">return</span> <span class="nam">header_size</span><span class="strut">&nbsp;</span></p>
<p id="t116" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t117" class="stm run hide_run">    <span class="key">def</span> <span class="nam">get_next_header</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t118" class="stm run hide_run">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_byte</span><span class="op">(</span><span class="num">0</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t119" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t120" class="stm run hide_run">    <span class="key">def</span> <span class="nam">get_header_extension_length</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t121" class="stm run hide_run">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_byte</span><span class="op">(</span><span class="num">1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t122" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t123" class="stm run hide_run">    <span class="key">def</span> <span class="nam">set_next_header</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">next_header</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t124" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">set_byte</span><span class="op">(</span><span class="num">0</span><span class="op">,</span> <span class="nam">next_header</span> <span class="op">&amp;</span> <span class="num">0xFF</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t125" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t126" class="stm run hide_run">    <span class="key">def</span> <span class="nam">set_header_extension_length</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">header_extension_length</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t127" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">set_byte</span><span class="op">(</span><span class="num">1</span><span class="op">,</span> <span class="nam">header_extension_length</span> <span class="op">&amp;</span> <span class="num">0xFF</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t128" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t129" class="stm run hide_run">    <span class="key">def</span> <span class="nam">add_option</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">option</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t130" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">_option_list</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">option</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t131" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t132" class="stm run hide_run">    <span class="key">def</span> <span class="nam">get_options</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t133" class="stm run hide_run">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_option_list</span><span class="strut">&nbsp;</span></p>
<p id="t134" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t135" class="stm run hide_run">    <span class="key">def</span> <span class="nam">get_packet</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t136" class="stm run hide_run">        <span class="nam">data</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_data_as_string</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t137" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t138" class="pln">        <span class="com"># Update the header length</span><span class="strut">&nbsp;</span></p>
<p id="t139" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">set_header_extension_length</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">get_header_size</span><span class="op">(</span><span class="op">)</span> <span class="op">//</span> <span class="num">8</span> <span class="op">-</span> <span class="num">1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t140" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t141" class="pln">        <span class="com"># Build the entire extension header packet</span><span class="strut">&nbsp;</span></p>
<p id="t142" class="stm run hide_run">        <span class="nam">header_bytes</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_buffer_as_string</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t143" class="stm run hide_run">        <span class="key">for</span> <span class="nam">option</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_option_list</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t144" class="stm run hide_run">            <span class="nam">header_bytes</span> <span class="op">+=</span> <span class="nam">option</span><span class="op">.</span><span class="nam">get_buffer_as_string</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t145" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t146" class="stm run hide_run">        <span class="key">if</span> <span class="nam">data</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t147" class="stm run hide_run">            <span class="key">return</span> <span class="nam">header_bytes</span> <span class="op">+</span> <span class="nam">data</span><span class="strut">&nbsp;</span></p>
<p id="t148" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t149" class="stm run hide_run">            <span class="key">return</span> <span class="nam">header_bytes</span><span class="strut">&nbsp;</span></p>
<p id="t150" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t151" class="stm run hide_run">    <span class="key">def</span> <span class="nam">contains</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">aHeader</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t152" class="stm run hide_run">        <span class="nam">Header</span><span class="op">.</span><span class="nam">contains</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">aHeader</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t153" class="stm run hide_run">        <span class="key">if</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">aHeader</span><span class="op">,</span> <span class="nam">IP6_Extension_Header</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t154" class="stm run hide_run">            <span class="nam">self</span><span class="op">.</span><span class="nam">set_next_header</span><span class="op">(</span><span class="nam">aHeader</span><span class="op">.</span><span class="nam">get_header_type</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t155" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t156" class="stm run hide_run">    <span class="key">def</span> <span class="nam">get_pseudo_header</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t157" class="pln">        <span class="com"># The pseudo-header only contains data from the IPv6 header.</span><span class="strut">&nbsp;</span></p>
<p id="t158" class="pln">        <span class="com"># So we pass the message to the parent until it reaches it.</span><span class="strut">&nbsp;</span></p>
<p id="t159" class="stm mis">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">parent</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">get_pseudo_header</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t160" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t161" class="stm run hide_run"><span class="key">class</span> <span class="nam">Extension_Option</span><span class="op">(</span><span class="nam">PacketBuffer</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t162" class="stm run hide_run">    <span class="nam">MAX_OPTION_LEN</span>  <span class="op">=</span> <span class="num">256</span><span class="strut">&nbsp;</span></p>
<p id="t163" class="stm run hide_run">    <span class="nam">OPTION_TYPE_VALUE</span> <span class="op">=</span> <span class="op">-</span><span class="num">1</span><span class="strut">&nbsp;</span></p>
<p id="t164" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t165" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">option_type</span><span class="op">,</span> <span class="nam">size</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t166" class="stm par run hide_run"><span class="annotate short">166&#x202F;&#x219B;&#x202F;167</span><span class="annotate long">line 166 didn't jump to line 167, because the condition on line 166 was never true</span>        <span class="key">if</span> <span class="nam">size</span> <span class="op">></span> <span class="nam">Extension_Option</span><span class="op">.</span><span class="nam">MAX_OPTION_LEN</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t167" class="stm mis">            <span class="key">raise</span> <span class="nam">ImpactPacketException</span><span class="op">(</span><span class="str">"Option size of % is greater than the maximum of %d"</span> <span class="op">%</span> <span class="op">(</span><span class="nam">size</span><span class="op">,</span> <span class="nam">Extension_Option</span><span class="op">.</span><span class="nam">MAX_OPTION_LEN</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t168" class="stm run hide_run">        <span class="nam">PacketBuffer</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">size</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t169" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">set_option_type</span><span class="op">(</span><span class="nam">option_type</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t170" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t171" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__str__</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t172" class="stm mis">        <span class="nam">option_type</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_option_type</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t173" class="stm mis">        <span class="nam">option_length</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_option_length</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t174" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t175" class="stm mis">        <span class="nam">s</span>  <span class="op">=</span> <span class="str">"Option Name: "</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">__class__</span><span class="op">.</span><span class="nam">OPTION_DESCRIPTION</span><span class="op">)</span> <span class="op">+</span> <span class="str">"\n"</span><span class="strut">&nbsp;</span></p>
<p id="t176" class="stm mis">        <span class="nam">s</span> <span class="op">+=</span> <span class="str">"Option Type: "</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">option_type</span><span class="op">)</span> <span class="op">+</span> <span class="str">"\n"</span><span class="strut">&nbsp;</span></p>
<p id="t177" class="stm mis">        <span class="nam">s</span> <span class="op">+=</span> <span class="str">"Option Length: "</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">option_length</span><span class="op">)</span> <span class="op">+</span> <span class="str">"\n"</span><span class="strut">&nbsp;</span></p>
<p id="t178" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t179" class="stm mis">        <span class="key">return</span> <span class="nam">s</span><span class="strut">&nbsp;</span></p>
<p id="t180" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t181" class="stm run hide_run">    <span class="key">def</span> <span class="nam">set_option_type</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">option_type</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t182" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">set_byte</span><span class="op">(</span><span class="num">0</span><span class="op">,</span> <span class="nam">option_type</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t183" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t184" class="stm run hide_run">    <span class="key">def</span> <span class="nam">get_option_type</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t185" class="stm run hide_run">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_byte</span><span class="op">(</span><span class="num">0</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t186" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t187" class="stm run hide_run">    <span class="key">def</span> <span class="nam">set_option_length</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">length</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t188" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">set_byte</span><span class="op">(</span><span class="num">1</span><span class="op">,</span> <span class="nam">length</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t189" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t190" class="stm run hide_run">    <span class="key">def</span> <span class="nam">get_option_length</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t191" class="stm run hide_run">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_byte</span><span class="op">(</span><span class="num">1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t192" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t193" class="stm run hide_run">    <span class="key">def</span> <span class="nam">set_data</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">data</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t194" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">set_option_length</span><span class="op">(</span><span class="nam">len</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t195" class="stm run hide_run">        <span class="nam">option_bytes</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_bytes</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t196" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t197" class="stm run hide_run">        <span class="nam">option_bytes</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_bytes</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t198" class="stm run hide_run">        <span class="nam">option_bytes</span><span class="op">[</span><span class="num">2</span><span class="op">:</span><span class="num">2</span><span class="op">+</span><span class="nam">len</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="op">]</span> <span class="op">=</span> <span class="nam">array</span><span class="op">.</span><span class="nam">array</span><span class="op">(</span><span class="str">'B'</span><span class="op">,</span> <span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t199" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">set_bytes</span><span class="op">(</span><span class="nam">option_bytes</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t200" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t201" class="stm run hide_run">    <span class="key">def</span> <span class="nam">get_len</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t202" class="stm run hide_run">        <span class="key">return</span> <span class="nam">len</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">get_bytes</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t203" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t204" class="stm run hide_run"><span class="key">class</span> <span class="nam">Option_PAD1</span><span class="op">(</span><span class="nam">Extension_Option</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t205" class="stm run hide_run">    <span class="nam">OPTION_TYPE_VALUE</span> <span class="op">=</span> <span class="num">0x00</span>   <span class="com"># Pad1 (RFC 2460)</span><span class="strut">&nbsp;</span></p>
<p id="t206" class="stm run hide_run">    <span class="nam">OPTION_DESCRIPTION</span> <span class="op">=</span> <span class="str">"Pad1 Option"</span><span class="strut">&nbsp;</span></p>
<p id="t207" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t208" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t209" class="stm run hide_run">        <span class="nam">Extension_Option</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">Option_PAD1</span><span class="op">.</span><span class="nam">OPTION_TYPE_VALUE</span><span class="op">,</span> <span class="num">1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t210" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t211" class="stm run hide_run">    <span class="key">def</span> <span class="nam">get_len</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t212" class="stm run hide_run">        <span class="key">return</span> <span class="num">1</span><span class="strut">&nbsp;</span></p>
<p id="t213" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t214" class="stm run hide_run"><span class="key">class</span> <span class="nam">Option_PADN</span><span class="op">(</span><span class="nam">Extension_Option</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t215" class="stm run hide_run">    <span class="nam">OPTION_TYPE_VALUE</span> <span class="op">=</span> <span class="num">0x01</span>   <span class="com"># Pad1 (RFC 2460)</span><span class="strut">&nbsp;</span></p>
<p id="t216" class="stm run hide_run">    <span class="nam">OPTION_DESCRIPTION</span> <span class="op">=</span> <span class="str">"PadN Option"</span><span class="strut">&nbsp;</span></p>
<p id="t217" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t218" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">padding_size</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t219" class="stm par run hide_run"><span class="annotate short">219&#x202F;&#x219B;&#x202F;220</span><span class="annotate long">line 219 didn't jump to line 220, because the condition on line 219 was never true</span>        <span class="key">if</span> <span class="nam">padding_size</span> <span class="op">&lt;</span> <span class="num">2</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t220" class="stm mis">            <span class="key">raise</span> <span class="nam">ImpactPacketException</span><span class="op">(</span><span class="str">"PadN Extension Option must be greater than 2 bytes"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t221" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t222" class="stm run hide_run">        <span class="nam">Extension_Option</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">Option_PADN</span><span class="op">.</span><span class="nam">OPTION_TYPE_VALUE</span><span class="op">,</span> <span class="nam">padding_size</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t223" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">set_data</span><span class="op">(</span><span class="str">b'\x00'</span> <span class="op">*</span> <span class="op">(</span><span class="nam">padding_size</span> <span class="op">-</span> <span class="num">2</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t224" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t225" class="stm run hide_run"><span class="key">class</span> <span class="nam">Basic_Extension_Header</span><span class="op">(</span><span class="nam">IP6_Extension_Header</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t226" class="stm run hide_run">    <span class="nam">MAX_OPTIONS_LEN</span> <span class="op">=</span> <span class="num">256</span> <span class="op">*</span> <span class="num">8</span><span class="strut">&nbsp;</span></p>
<p id="t227" class="stm run hide_run">    <span class="nam">MIN_HEADER_LEN</span>  <span class="op">=</span> <span class="num">8</span><span class="strut">&nbsp;</span></p>
<p id="t228" class="stm run hide_run">    <span class="nam">MAX_HEADER_LEN</span>  <span class="op">=</span> <span class="nam">MIN_HEADER_LEN</span> <span class="op">+</span> <span class="nam">MAX_OPTIONS_LEN</span><span class="strut">&nbsp;</span></p>
<p id="t229" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t230" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">buffer</span> <span class="op">=</span> <span class="key">None</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t231" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">padded</span> <span class="op">=</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t232" class="stm run hide_run">        <span class="nam">IP6_Extension_Header</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">buffer</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t233" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t234" class="stm run hide_run">    <span class="key">def</span> <span class="nam">reset</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t235" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">set_next_header</span><span class="op">(</span><span class="num">0</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t236" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">set_header_extension_length</span><span class="op">(</span><span class="num">0</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t237" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_padding</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t238" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t239" class="stm run hide_run">    <span class="key">def</span> <span class="nam">add_option</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">option</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t240" class="stm run hide_run">        <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">padded</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t241" class="stm run hide_run">            <span class="nam">self</span><span class="op">.</span><span class="nam">_option_list</span><span class="op">.</span><span class="nam">pop</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t242" class="stm run hide_run">            <span class="nam">self</span><span class="op">.</span><span class="nam">padded</span> <span class="op">=</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t243" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t244" class="stm run hide_run">        <span class="nam">IP6_Extension_Header</span><span class="op">.</span><span class="nam">add_option</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">option</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t245" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t246" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_padding</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t247" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t248" class="stm run hide_run">    <span class="key">def</span> <span class="nam">add_padding</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t249" class="stm run hide_run">        <span class="nam">required_octets</span> <span class="op">=</span> <span class="num">8</span> <span class="op">-</span> <span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">get_header_size</span><span class="op">(</span><span class="op">)</span> <span class="op">%</span> <span class="num">8</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t250" class="stm par run hide_run"><span class="annotate short">250&#x202F;&#x219B;&#x202F;251</span><span class="annotate long">line 250 didn't jump to line 251, because the condition on line 250 was never true</span>        <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_header_size</span><span class="op">(</span><span class="op">)</span> <span class="op">+</span> <span class="nam">required_octets</span> <span class="op">></span> <span class="nam">Basic_Extension_Header</span><span class="op">.</span><span class="nam">MAX_HEADER_LEN</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t251" class="stm mis">            <span class="key">raise</span> <span class="nam">Exception</span><span class="op">(</span><span class="str">"Not enough space for the padding"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t252" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t253" class="pln">        <span class="com"># Insert Pad1 or PadN to fill the necessary octets</span><span class="strut">&nbsp;</span></p>
<p id="t254" class="stm run hide_run">        <span class="key">if</span> <span class="num">0</span> <span class="op">&lt;</span> <span class="nam">required_octets</span> <span class="op">&lt;</span> <span class="num">8</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t255" class="stm par run hide_run"><span class="annotate short">255&#x202F;&#x219B;&#x202F;256</span><span class="annotate long">line 255 didn't jump to line 256, because the condition on line 255 was never true</span>            <span class="key">if</span> <span class="nam">required_octets</span> <span class="op">==</span> <span class="num">1</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t256" class="stm mis">                <span class="nam">self</span><span class="op">.</span><span class="nam">add_option</span><span class="op">(</span><span class="nam">Option_PAD1</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t257" class="pln">            <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t258" class="stm run hide_run">                <span class="nam">self</span><span class="op">.</span><span class="nam">add_option</span><span class="op">(</span><span class="nam">Option_PADN</span><span class="op">(</span><span class="nam">required_octets</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t259" class="stm run hide_run">            <span class="nam">self</span><span class="op">.</span><span class="nam">padded</span> <span class="op">=</span> <span class="key">True</span><span class="strut">&nbsp;</span></p>
<p id="t260" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t261" class="stm run hide_run">            <span class="nam">self</span><span class="op">.</span><span class="nam">padded</span> <span class="op">=</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t262" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t263" class="stm run hide_run"><span class="key">class</span> <span class="nam">Hop_By_Hop</span><span class="op">(</span><span class="nam">Basic_Extension_Header</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t264" class="stm run hide_run">    <span class="nam">HEADER_TYPE_VALUE</span> <span class="op">=</span> <span class="num">0x00</span><span class="strut">&nbsp;</span></p>
<p id="t265" class="stm run hide_run">    <span class="nam">HEADER_EXTENSION_DESCRIPTION</span> <span class="op">=</span> <span class="str">"Hop By Hop Options"</span><span class="strut">&nbsp;</span></p>
<p id="t266" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t267" class="stm run hide_run">    <span class="op">@</span><span class="nam">classmethod</span><span class="strut">&nbsp;</span></p>
<p id="t268" class="pln">    <span class="key">def</span> <span class="nam">get_decoder</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t269" class="stm run hide_run">        <span class="key">from</span> <span class="nam">impacket</span> <span class="key">import</span> <span class="nam">ImpactDecoder</span><span class="strut">&nbsp;</span></p>
<p id="t270" class="stm run hide_run">        <span class="key">return</span> <span class="nam">ImpactDecoder</span><span class="op">.</span><span class="nam">HopByHopDecoder</span><span class="strut">&nbsp;</span></p>
<p id="t271" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t272" class="stm run hide_run"><span class="key">class</span> <span class="nam">Destination_Options</span><span class="op">(</span><span class="nam">Basic_Extension_Header</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t273" class="stm run hide_run">    <span class="nam">HEADER_TYPE_VALUE</span> <span class="op">=</span> <span class="num">0x3c</span><span class="strut">&nbsp;</span></p>
<p id="t274" class="stm run hide_run">    <span class="nam">HEADER_EXTENSION_DESCRIPTION</span> <span class="op">=</span> <span class="str">"Destination Options"</span><span class="strut">&nbsp;</span></p>
<p id="t275" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t276" class="stm run hide_run">    <span class="op">@</span><span class="nam">classmethod</span><span class="strut">&nbsp;</span></p>
<p id="t277" class="pln">    <span class="key">def</span> <span class="nam">get_decoder</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t278" class="stm run hide_run">        <span class="key">from</span> <span class="nam">impacket</span> <span class="key">import</span> <span class="nam">ImpactDecoder</span><span class="strut">&nbsp;</span></p>
<p id="t279" class="stm run hide_run">        <span class="key">return</span> <span class="nam">ImpactDecoder</span><span class="op">.</span><span class="nam">DestinationOptionsDecoder</span><span class="strut">&nbsp;</span></p>
<p id="t280" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t281" class="stm run hide_run"><span class="key">class</span> <span class="nam">Routing_Options</span><span class="op">(</span><span class="nam">IP6_Extension_Header</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t282" class="stm run hide_run">    <span class="nam">HEADER_TYPE_VALUE</span> <span class="op">=</span> <span class="num">0x2b</span><span class="strut">&nbsp;</span></p>
<p id="t283" class="stm run hide_run">    <span class="nam">HEADER_EXTENSION_DESCRIPTION</span> <span class="op">=</span> <span class="str">"Routing Options"</span><span class="strut">&nbsp;</span></p>
<p id="t284" class="stm run hide_run">    <span class="nam">ROUTING_OPTIONS_HEADER_FIELDS_SIZE</span> <span class="op">=</span> <span class="num">8</span><span class="strut">&nbsp;</span></p>
<p id="t285" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t286" class="stm run hide_run">    <span class="key">def</span> <span class="nam">reset</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t287" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">set_next_header</span><span class="op">(</span><span class="num">0</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t288" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">set_header_extension_length</span><span class="op">(</span><span class="num">0</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t289" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">set_routing_type</span><span class="op">(</span><span class="num">0</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t290" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">set_segments_left</span><span class="op">(</span><span class="num">0</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t291" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t292" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__str__</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t293" class="stm mis">        <span class="nam">header_type</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_header_type</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t294" class="stm mis">        <span class="nam">next_header_value</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_next_header</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t295" class="stm mis">        <span class="nam">header_ext_length</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_header_extension_length</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t296" class="stm mis">        <span class="nam">routing_type</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_routing_type</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t297" class="stm mis">        <span class="nam">segments_left</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_segments_left</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t298" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t299" class="stm mis">        <span class="nam">s</span>  <span class="op">=</span> <span class="str">"Header Extension Name: "</span> <span class="op">+</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__class__</span><span class="op">.</span><span class="nam">HEADER_EXTENSION_DESCRIPTION</span> <span class="op">+</span> <span class="str">"\n"</span><span class="strut">&nbsp;</span></p>
<p id="t300" class="stm mis">        <span class="nam">s</span> <span class="op">+=</span> <span class="str">"Header Type Value: "</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">header_type</span><span class="op">)</span> <span class="op">+</span> <span class="str">"\n"</span><span class="strut">&nbsp;</span></p>
<p id="t301" class="stm mis">        <span class="nam">s</span> <span class="op">+=</span> <span class="str">"Next Header: "</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">next_header_value</span><span class="op">)</span> <span class="op">+</span> <span class="str">"\n"</span><span class="strut">&nbsp;</span></p>
<p id="t302" class="stm mis">        <span class="nam">s</span> <span class="op">+=</span> <span class="str">"Header Extension Length: "</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">header_ext_length</span><span class="op">)</span> <span class="op">+</span> <span class="str">"\n"</span><span class="strut">&nbsp;</span></p>
<p id="t303" class="stm mis">        <span class="nam">s</span> <span class="op">+=</span> <span class="str">"Routing Type: "</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">routing_type</span><span class="op">)</span> <span class="op">+</span> <span class="str">"\n"</span><span class="strut">&nbsp;</span></p>
<p id="t304" class="stm mis">        <span class="nam">s</span> <span class="op">+=</span> <span class="str">"Segments Left: "</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">segments_left</span><span class="op">)</span> <span class="op">+</span> <span class="str">"\n"</span><span class="strut">&nbsp;</span></p>
<p id="t305" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t306" class="stm mis">        <span class="key">return</span> <span class="nam">s</span><span class="strut">&nbsp;</span></p>
<p id="t307" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t308" class="stm run hide_run">    <span class="op">@</span><span class="nam">classmethod</span><span class="strut">&nbsp;</span></p>
<p id="t309" class="pln">    <span class="key">def</span> <span class="nam">get_decoder</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t310" class="stm run hide_run">        <span class="key">from</span> <span class="op">.</span> <span class="key">import</span> <span class="nam">ImpactDecoder</span><span class="strut">&nbsp;</span></p>
<p id="t311" class="stm run hide_run">        <span class="key">return</span> <span class="nam">ImpactDecoder</span><span class="op">.</span><span class="nam">RoutingOptionsDecoder</span><span class="strut">&nbsp;</span></p>
<p id="t312" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t313" class="stm run hide_run">    <span class="key">def</span> <span class="nam">get_headers_field_size</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t314" class="stm run hide_run">        <span class="key">return</span> <span class="nam">Routing_Options</span><span class="op">.</span><span class="nam">ROUTING_OPTIONS_HEADER_FIELDS_SIZE</span><span class="strut">&nbsp;</span></p>
<p id="t315" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t316" class="stm run hide_run">    <span class="key">def</span> <span class="nam">set_routing_type</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">routing_type</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t317" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">set_byte</span><span class="op">(</span><span class="num">2</span><span class="op">,</span> <span class="nam">routing_type</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t318" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t319" class="stm run hide_run">    <span class="key">def</span> <span class="nam">get_routing_type</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t320" class="stm run hide_run">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_byte</span><span class="op">(</span><span class="num">2</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t321" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t322" class="stm run hide_run">    <span class="key">def</span> <span class="nam">set_segments_left</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">segments_left</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t323" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">set_byte</span><span class="op">(</span><span class="num">3</span><span class="op">,</span> <span class="nam">segments_left</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t324" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t325" class="stm run hide_run">    <span class="key">def</span> <span class="nam">get_segments_left</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t326" class="stm run hide_run">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_byte</span><span class="op">(</span><span class="num">3</span><span class="op">)</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-25 12:47
        </p>
    </div>
</div>

</body>
</html>
